const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const comments = sequelize.define(
    'comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

target_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"problem_report",


"solution_proposal",


"course",


"lesson"

        ],

      },

content: {
        type: DataTypes.TEXT,
      
      

      },

posted_at: {
        type: DataTypes.DATE,
      
      

      },

is_pinned: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  comments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.comments.belongsTo(db.problem_reports, {
      as: 'problem_report',
      foreignKey: {
        name: 'problem_reportId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.solution_proposals, {
      as: 'solution_proposal',
      foreignKey: {
        name: 'solution_proposalId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.courses, {
      as: 'course',
      foreignKey: {
        name: 'courseId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.lessons, {
      as: 'lesson',
      foreignKey: {
        name: 'lessonId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return comments;
};


